discussion/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls)
]

todolist/urls.py
from django.urls import path
from . import views

# Adding a namespace to this urls.py help django to distinguish this set of routes ferom other urls.py files in other packages.
app_name = 'todolist'
urlpatterns = [
    path('', views.index, name="index"),
    # localhost:8000/todolist/1
    path('<int:todoitem_id>/', views.todoitem, name="viewtodoitem"),
    # localhost:8000/todolist/register
    path('register/', views.register, name="register"),
    # localhost:8000/todolist/update-profile
    path('update-profile/', views.update_profile, name="update_profile"),
    # localhost:8000/todolist/login
    path('login/', views.login_view, name="login"),
    # localhost:8000/todolist/logout
    path('logout/', views.logout_view, name="logout"),
    # localhost:8000/todolist/add_task,
    path('add_task/', views.add_task, name="add_task"),
   # localhost:8000/todolist/1/edit
    path('<int:todoitem_id>/edit', views.update_task, name="update_task"),
    # localhost:8000/todolist/1/delete
    path('<int:todoitem_id>/delete', views.delete_task, name="delete_task"),
    # localhost:8000/todolist/event/1
    path('event/<int:eventitem_id>', views.eventitem, name="vieweventitem"),
    # localhost:8000/todolist/add_event
    path('add_event/', views.add_event, name="add_event"),
    # localhost:8000/todolist/1/delete_event
    path('<int:eventitem_id>/delete_event', views.delete_event, name="delete_event"),
    # localhost:8000/todolist/1/edit_event
    path('<int:eventitem_id>/edit_event', views.update_event, name="update_event"),
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
    # 'CharField' = String
    # DataTimeField = DateTime datatype
    task_name = models.CharField(max_length = 50)
    description = models.CharField(max_length = 200)
    status = models.CharField(max_length = 50, default = "Pending")
    date_created = models.DateTimeField("Date Created")
    # Adding a user_id to the ToDoItem table, which is a foreign key connected to the User's table
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class EventsItem(models.Model):
    event_name = models.CharField(max_length = 50)
    description = models.CharField(max_length = 200)
    status = models.CharField(max_length = 50, default = "Pending")
    event_date= models.DateTimeField("Event's Date")
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
    task_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)

class UpdateTaskForm(forms.Form):
    task_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    status = forms.CharField(label="Status", max_length=20)

class AddEventForm(forms.Form):
    event_name = forms.CharField(label="Event Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    event_date = forms.DateTimeField(
                input_formats=['%d/%m/%Y %H:%M'],
                widget=forms.DateTimeInput(attrs={
                    'class': 'form-control datetimepicker-input',
                    'data-target': '#datetimepicker1'
                })
                )

class UpdateEventForm(forms.Form):
    event_name = forms.CharField(label="Event Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    event_date = forms.DateTimeField(
                input_formats=['%d/%m/%Y %H:%M'],
                widget=forms.DateTimeInput(attrs={
                    'class': 'form-control datetimepicker-input',
                    'data-target': '#datetimepicker1'
                })
                )
    status = forms.CharField(label="Status", max_length=20)

class UpdateProfile(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    password = forms.CharField(label="Password", max_length=50)
    new_password = forms.CharField(label="Password", max_length=50)
    new_first_name = forms.CharField(label="First Name", max_length=50)
    new_last_name = forms.CharField(label="Last Name", max_length=50)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponse
from django.template import loader
from django.utils import timezone

# We import the built-in 'User' model to be able to do operations to the built-in Users table from Django
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from .models import ToDoItem, EventsItem
from .forms import LoginForm, AddTaskForm, UpdateTaskForm, AddEventForm, UpdateEventForm, UpdateProfile

# Create your views here.
def index(request):
    # todoitem_list = ToDoItem.objects.all()
    todoitem_list = ToDoItem.objects.filter(user_id=request.user.id)
    eventitem_list = EventsItem.objects.filter(user_id=request.user.id)
    template = loader.get_template('todolist/index.html')
    context = {
        'todoitem_list': todoitem_list,
        'eventitem_list': eventitem_list,
        'user': request.user
    }
    # output = ', '.join([todoitem.task_name for todoitem in todoitem_list])
    return HttpResponse(template.render(context, request))
    # You can also render a template by this way
    # return render(request, "todolist/index.html", context)

def todoitem(request, todoitem_id):
    # todoitem = model_to_dict(ToDoItem.objects.get(pk=todoitem_id))
    todoitem = get_object_or_404(ToDoItem,pk=todoitem_id)
    # response = "You are viewing the details of %s"
    # return HttpResponse(response % todoitem_id)
    return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def register(request):
    users = User.objects.all()
    is_user_registered = False

    # loops through each existing user and checks if they already exist in the table
    for individual_user in users:
        if individual_user.username == "johndoe":
            is_user_registered = True
            break
    
    # The context 'is_user_registered" is put after the for loop in order for it to get the updated value if 'for loop above equals to True
    context = {
        "is_user_registered": is_user_registered
    }

    if is_user_registered == False:    
        # 1. Creating a new instance of the User Model.
        user = User()

         # 2. Assign data values to each property of the model
        user.username = "johndoe"
        user.first_name = "John"
        user.last_name = "Doe"
        user.email = "john@mail.com"
        user.set_password("john1234")
        user.is_staff = False
        user.is_active = True

        # 3. Save the new instance of a user into the database.
        user.save()

        # The content will be the data to be passed to the template
        context = {
            "first_name": user.first_name,
            "last_name": user.last_name
        }

    return render(request, "todolist/register.html", context)

def update_profile(request):

    context = {
        "user": request.user,
        "first_name": User.first_name,
        "lastname": User.last_name
    }

    user = authenticate(username=request.user.username, password=request.user.password)

    is_user_authenticated = False

    if request.method == 'POST':

        form = UpdateProfile(request.POST)

        if form.is_valid() == False:

            form = UpdateProfile()
            
        else:

            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            new_password = form.cleaned_data['new_password']
            new_first_name = form.cleaned_data['new_first_name']
            new_last_name = form.cleaned_data['new_last_name']
        
        
        
            if username == user.username and password == user.password:
                is_user_authenticated = True

            else:
                is_user_authenticated = False


        if user is not None:
                authenticated_user = User.objects.get(username=request.user.username)
                    

                authenticated_user.set_password(new_password)
                authenticated_user.first_name = new_first_name
                authenticated_user.last_name = new_last_name
                authenticated_user.save()

        context = {
        "is_user_authenticated": is_user_authenticated
        }
        


    
    return render(request, "todolist/update_profile.html", context)

def login_view(request):
    context = {}

    if request.method == 'POST':
        # request.POST contains all the field's data coming from the Login.html form
        form = LoginForm(request.POST)

        if form.is_valid() == False:
            # if you use LoginForm() without passing any data, it will just return the properties 'username' and 'password' without any data/value
            form = LoginForm()
        else:
            # we use the 'form.cleaned_data[]' to get the properties that we need from the form
            # we can use the properties declared in the form.py whithin the loginform class to get their values
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']

            user = authenticate(username=username, password=password)

            context = {
                "username": username,
                "password": password
            }

            if user is not None:
                # The 'login' function saves the user's ID in Django's session. The request will be the one that handles the user's data and we can access the user by using 'request.user'.
                login(request, user)
                return redirect("todolist:index")
            else:
                context = {
                    "error": True
                }
                     
    return render(request, "todolist/login.html", context)

def logout_view(request):
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}

    if request.method == 'POST':

        form = AddTaskForm(request.POST)

        if form.is_valid() == False:

            form = AddTaskForm()
        else:

            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            # fliter checks for existing tasknames
            duplicates = ToDoItem.objects.filter(task_name=task_name)

            if not duplicates:
                ToDoItem.objects.create(
                    task_name=task_name,
                    description=description,
                    date_created=timezone.now(),
                    user_id=request.user.id #ID of the logged in user
                    )

                return redirect('todolist:index')
            else:
                context = {
                    "error": True
                }
                     
    return render(request, "todolist/add_task.html", context)

def update_task(request, todoitem_id):
    # Returns a queryset
    todoitem = ToDoItem.objects.filter(pk=todoitem_id)

    context = {
        "user": request.user,
        "todoitem_id": todoitem_id,
        # Accessing the first element is necessary because the "ToDoItem.objects.filter()" method returns a queryset
        "task_name": todoitem[0].task_name,
        "description": todoitem[0].description,
        "status": todoitem[0].status
    }

    if request.method == 'POST':

        form = UpdateTaskForm(request.POST)

        if form.is_valid() == False:

            form = UpdateTaskForm()

        else:

            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']
            
            if todoitem:

                todoitem[0].task_name = task_name
                todoitem[0].description = description
                todoitem[0].status = status

                todoitem[0].save()
                return redirect("todolist:index")

            else:

                context = {
                    "error": True
                }

    return render(request, "todolist/update_task.html", context)

def delete_task(request, todoitem_id):
	todoitem = ToDoItem.objects.filter(pk=todoitem_id)

	todoitem.delete()

	return redirect("todolist:index")

def add_event(request):
    context = {}

    if request.method == 'POST':

        form = AddEventForm(request.POST)

        if form.is_valid() == False:

            form = AddEventForm()
        else:

            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            event_date = form.cleaned_data['event_date']
            # Check Duplicates
            duplicates = EventsItem.objects.filter(event_name=event_name)

            if not duplicates:
                EventsItem.objects.create(
                    event_name=event_name,
                    description=description,
                    event_date=event_date,
                    user_id=request.user.id #ID of the logged in user
                    )

                return redirect('todolist:index')
            else:
                context = {
                    "error": True
                }
                     
    return render(request, "todolist/add_event.html", context)

def eventitem(request, eventitem_id):
    eventitem = get_object_or_404(EventsItem,pk=eventitem_id)
    return render(request, "todolist/eventitem.html", model_to_dict(eventitem))

def delete_event(request, eventitem_id):
	eventitem = EventsItem.objects.filter(pk=eventitem_id)

	eventitem.delete()

	return redirect("todolist:index")

def update_event(request, eventitem_id):

    eventitem = EventsItem.objects.filter(pk=eventitem_id)

    context = {
        "user": request.user,
        "eventitem_id": eventitem_id,
        "event_name": eventitem[0].event_name,
        "description": eventitem[0].description,
        "event_date": eventitem[0].event_date,
        "status": eventitem[0].status
    }

    if request.method == 'POST':

todolist/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- 'block' keyword states that the data is innheritable, which means you can use the name of it which is 'title' to later on add new data/html-->
    <title>{% block title %} ToDo App {% endblock %}</title>
    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
    integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
    crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.6/umd/popper.min.js"
    integrity="sha384-wHAiFfRlMFy6i5SRaxvfOCifBUQy1xHdJ/yoi7FRNXMRBu5WHdZYu1hA6ZOblgut"
    crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/js/bootstrap.min.js"
    integrity="sha384-B0UglyR+jN6CkvvICOB2joaf5I4l3gm9GU6Hc1og6Ls7i6U/mkkaduKaBhlAXv9k"
    crossorigin="anonymous"></script>
<!-- Font Awesome -->
<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet"
    integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN" crossorigin="anonymous">
<!-- Moment.js -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.23.0/moment.min.js"
    integrity="sha256-VBLiveTKyUZMEzJd6z2mhfxIqz3ZATCuVMawPZGzIfA=" crossorigin="anonymous"></script>
<!-- Tempus Dominus Bootstrap 4 -->
<link rel="stylesheet"
    href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.1.2/css/tempusdominus-bootstrap-4.min.css"
    integrity="sha256-XPTBwC3SBoWHSmKasAk01c08M6sIA5gF5+sRxqak2Qs=" crossorigin="anonymous" />
<script
    src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.1.2/js/tempusdominus-bootstrap-4.min.js"
    integrity="sha256-z0oKYg6xiLq3yJGsp/LsY9XykbweQlHl42jHv2XTBz4=" crossorigin="anonymous"></script>
</head>
<body>
    <!-- Navbar -->
    {% include "navbar.html" %}

    <!-- Content -->
    {% block content %}
    {% endblock %}
    <!-- Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
</body>

</html>

todolist/templates/navbar.html
<nav class="navbar navbar-expand-lg bg-warning">
    <div class="container-fluid">
      <a class="navbar-brand" href="#">To Do App</a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav ms-auto">
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:index' %}">Home</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:add_task' %}">Add Task</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:add_event' %}">Add Event</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:update_profile' %}">Update Profile</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:login' %}">Login</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'todolist:logout' %}">Logout</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>